Unit IkCon16;

interface
{
 Constants and Declarations for ImageKnife/VBX library

 Copyright (c); 1995 by Media Architects; Inc.  ALL RIGHTS RESERVED
}

uses BiVBX,WinTypes, WinProcs, SysUtils;

Const
        { Image file formats }
	IK_EXTENSION :integer = 0;
	IK_TIFF :integer= 1;
	IK_TARGA :integer= 2;
	IK_BITMAP :integer= 3;
	IK_GIF :integer= 4;
	IK_DIB :integer= 5;
	IK_PCX :integer= 6;
	IK_JPEG :integer= 7;
	IK_OLEPBRUSH :integer= 8;
	IK_FIF :integer= 9;

	{ Image file compression types }
	IK_UNCOMP :integer= 0;
	IK_LZW :integer= 1;
	IK_RLE :integer= 2;
	IK_PACKBITS :integer= 3;
	IK_OS2 :integer= 4;
	IK_PCXCOMP :integer= 5;

{ Scrollbar types }
	IK_SB_NONE :integer= 0;
	IK_SB_HORZ :integer= 1;
	IK_SB_VERT :integer= 2;
	IK_SB_BOTH :integer= 3;

{ Load Options }
	IK_FIF_24_BIT           :integer= 0;
	IK_FIF_8_BIT_DITHERED   :integer= 1;
	IK_FIF_4_BIT_DITHERED   :integer= 2;
	IK_FIF_8_BIT_NODITHERED :integer= 3;
	IK_FIF_4_BIT_NODITHERED :integer= 4;

{ Load Scale }
	IK_FULL_SCALE   :integer= 0;
	IK_HALF_SCALE   :integer= 1;
	IK_DOUBLE_SCALE :integer= 2;
	IK_IGNORE_SCALE :integer= 3;

{ Contents }
	IK_CT_EMPTY :integer= 0;
	IK_CT_DIB   :integer= 1;
	IK_CT_PAL   :integer= 2;

{ ikDumpControl  }
	IK_DC_IMAGE_PALETTE :integer= 0;
	IK_DC_IMAGE         :integer= 1;
	IK_DC_PALETTE       :integer= 2;

{  Types }

type
  PointAPI = record X, Y: integer end;


{ Declarations }

{access not supported under delphi
Procedure ikAccessLoad (hctl: POINTER; Chunks(); As String * 32768);
Procedure ikAccessStoreDone ();
Function ikAccessStoreInit      (hctl: POINTER;  ChunkSize:LONGINT):LONGINT;
Function ikAccessStoreGetData   ( ChunkNum:LONGINT); As String
}

{ Function Prototypes }
var

ikAddSystemColors: procedure      (hctl: POINTER);
ikLoad:procedure                  (hctl: POINTER);
ikAppendTiff:Procedure           (hctl: POINTER);
ikArc:Procedure                  (hctl: POINTER;  XStart:Integer;  YStart:Integer;  XEnd:Integer;  YEnd:Integer);
ikAssign:Procedure               (hctl: POINTER;  DestSelection:Integer; Sourcehctl: POINTER;  SourceSelection:Integer);
ikBitmapToDib :Procedure         (hctl: POINTER;  hBitmap:Integer);
ikBlur:Procedure                 (hctl: POINTER);
ikBrightCont :Procedure          (hctl: POINTER;  Brightness:DOUBLE;  Contrast:DOUBLE);
ikChord:Procedure                (hctl: POINTER;  XStart:Integer;  YStart:Integer;  XEnd:Integer;  YEnd:Integer);
ikClear :Procedure               (hctl: POINTER);
 ikColorReplace :Procedure        (hctl: POINTER;  C1:LONGINT;  C2:LONGINT;  Flag:Integer;  C3:LONGINT);
ikCountImages:function         (hctl: POINTER) :Integer;
ikCountSystemColors:function    (hctl: POINTER) :Integer;
 ikCreatePalette:Procedure        (hctl: POINTER;  Count:Integer; Buffer:LONGINT;  SystemColors:Integer );
 ikDibToBitmap:Function          (hctl: POINTER) :Integer;
 ikDitherPal:Procedure            (hctl: POINTER; Palettehctl: POINTER);
 ikDumpControl:Procedure          (hctl: POINTER;  DumpOption:Integer );
 ikDuplicateDib:Function         (hctl: POINTER;  SelectionFlag:Integer) :Integer;
 ikDuplicatePalette:Function     (hctl: POINTER) :Integer;
 ikExtractEdges:Procedure         (hctl: POINTER;  Magnitude:Integer);
 ikGamma:Procedure                (hctl: POINTER;  Magnitude:DOUBLE);
 ikGetColor :Function            (hctl: POINTER;  X:Integer;  Y:Integer):LONGINT;
 ikGetColorCount:Function        (hctl: POINTER):LONGINT;
 ikGetColorCountArray:Procedure   (hctl: POINTER; Buffer :Pointer);
 ikGetHorzSBHeight:Function       :Integer;
 ikGetPalColor:Function          (hctl: POINTER;  position:Integer):LONGINT;
 ikGetPalIndex:Function          (hctl: POINTER;  X:Integer;  Y:Integer) :Integer;
 ikGetPalette :Procedure          (hctl: POINTER; Buffer :POINTER);
 ikGetScanLine:Procedure         (hctl: POINTER;  LineNo:Integer; Buffer :POINTER);
 ikGetVertSBWidth:Function       :Integer;
 ikGrayScale:Procedure            (hctl: POINTER);
 ikIncreaseColors:Procedure       (hctl: POINTER;  Depth:Integer);
 ikInit:Procedure                 (hctl: POINTER;  ColorDepth:Integer;
          NewWidth:Integer;  NewHeight:Integer;  NewColor:LONGINT);

 ikLoadCallback:Procedure         (hctl: POINTER; PeekCntl :POINTER);
 ikLoadCursor:Procedure           ( Index:Integer;  Libfile:Pchar;  CursorName:Pchar);
 ikLoadPegasus :Procedure         (hctl: POINTER);
 ikLoadPal :Procedure             (hctl: POINTER);
 ikMaskCopy :Procedure            (hctl: POINTER; Sourcehctl: POINTER; Maskhctl: POINTER);
 ikMatrixFilter:Procedure         (hctl: POINTER;  MatrixSize:Integer;
          Matrix :Integer;  MatrixScale:Integer;  MatrixNorm:Integer;  MatrixOffset:Integer);
 ikMirror:Procedure               (hctl: POINTER;  BoolHoriz:Integer;  BoolVert:Integer);
 ikNegate:Procedure               (hctl: POINTER);
 ikOptimizePal:Procedure          (hctl: POINTER; PicBufs :POINTER;  ImgCount:Integer;  Colors:Integer);
 ikRect :Procedure                (hctl: POINTER );
 ikReduceColors :Procedure        (hctl: POINTER;  Colors:Integer;  Optimize:Integer;  Dither:Integer;  NoBleed:Integer);
 ikReduceColorsCallback:Procedure (hctl: POINTER;  Colors:Integer;
          Optimize:Integer;  Dither:Integer;  NoBleed:Integer ;PeekCntl :POINTER);
 ikRemapPal:Procedure             (hctl: POINTER; Palettehctl: POINTER);
 ikRePos:Procedure                (hctl: POINTER;  ImageX:Integer;  ImageY:Integer;  CtlX:Integer;  CtlY:Integer);
 ikRotate:Procedure               (hctl: POINTER;  Angle:Integer;  BackColor:LONGINT);
 ikRoundRect:Procedure            (hctl: POINTER;  ElipseWidth:Integer;  ElipseHeight:Integer );
 ikPie :Procedure                 (hctl: POINTER;  XStart:Integer;  YStart:Integer;  XEnd:Integer;  YEnd:Integer);
 ikPolygon :Procedure             (hctl: POINTER; Points :POINTER;  nPoints:Integer;  bWinding:Integer );
 ikPolyLine :Procedure            (hctl: POINTER; Points :POINTER;  nPoints:Integer);
 ikPutScanLine:Procedure          (hctl: POINTER;  LineNo:Integer; Buffer :POINTER);
 ikScreenToImageX :Function      (hctl: POINTER;  X:Integer) :Integer;
 ikScreenToImageY :Function      (hctl: POINTER;  Y:Integer) :Integer;
 ikSetPalColor  :Procedure        (hctl: POINTER;  Index:Integer;  VBcolor:Longint);
 ikSetScreenPal:Procedure         (hctl: POINTER);
 ikSharpen:Procedure              (hctl: POINTER;  Sharpness:Integer);
 ikSoften:Procedure               (hctl: POINTER;  Softness:Integer);
 ikStore:Procedure                (hctl: POINTER);
 ikStorePal:Procedure             (hctl: POINTER);
 ikTextDraw :Procedure            (hctl: POINTER);
 ikVerify : Function             ( hDIB:Integer) :Integer;
 ikView:Procedure                 (hctl: POINTER; Viewedhctl: POINTER);

implementation
{ +++++++++++++++++++ }

var
  hCIKHandle: THandle;

procedure ImageKnife_End; far;
begin
  FreeLibrary(hCIKHandle);
end;

begin
  hCIKHandle :=
LoadLibrary('ikdsp16.vbx');
  AddExitProc(ImageKnife_End);

@ikAddSystemColors := GetProcAddress(hCIKHandle,'ikAddSystemColors');
@ikAppendTiff:= GetProcAddress(hCIKHandle,'ikAppendTiff');
@ikArc:= GetProcAddress(hCIKHandle,'ikArc');
@ikAssign:= GetProcAddress(hCIKHandle,'ikAssign');
@ikBitmapToDib:= GetProcAddress(hCIKHandle,'ikBitmapToDib');
@ikBlur:= GetProcAddress(hCIKHandle,'ikBlur');
@ikBrightCont:= GetProcAddress(hCIKHandle,'ikBrightCont');
@ikChord:= GetProcAddress(hCIKHandle,'ikChord');
@ikClear:= GetProcAddress(hCIKHandle,'ikClear');
@ikColorReplace:= GetProcAddress(hCIKHandle,'ikColorReplace');
@ikCountImages:= GetProcAddress(hCIKHandle,'ikCountImages');
@ikCountSystemColors:= GetProcAddress(hCIKHandle,'ikCountSystemColors');
@ikCreatePalette:= GetProcAddress(hCIKHandle,'ikCreatePalette');
@ikDibToBitmap:= GetProcAddress(hCIKHandle,'ikDibToBitmap');
@ikDitherPal:= GetProcAddress(hCIKHandle,'ikDitherPal');
@ikDumpControl:= GetProcAddress(hCIKHandle,'ikDumpControl');
@ikDuplicateDib:= GetProcAddress(hCIKHandle,'ikDuplicateDib');
@ikDuplicatePalette := GetProcAddress(hCIKHandle,'ikDuplicatePalette');
@ikExtractEdges:= GetProcAddress(hCIKHandle,'ikExtractEdges');
@ikGamma:= GetProcAddress(hCIKHandle,'ikGamma');
@ikGetColor:= GetProcAddress(hCIKHandle,'ikGetColor');
@ikGetColorCount:= GetProcAddress(hCIKHandle,'ikGetColorCount');
@ikGetColorCountArray:= GetProcAddress(hCIKHandle,'ikGetColorCountArray');
@ikGetHorzSBHeight:= GetProcAddress(hCIKHandle,'ikGetHorzSBHeight');
@ikGetPalColor := GetProcAddress(hCIKHandle,'ikGetPalColor');
@ikGetPalIndex:= GetProcAddress(hCIKHandle,'ikGetPalIndex');
@ikGetPalette := GetProcAddress(hCIKHandle,'ikGetPalette');
@ikGetScanLine := GetProcAddress(hCIKHandle,'ikGetScanLine');
@ikGetVertSBWidth := GetProcAddress(hCIKHandle,'ikGetVertSBWidth');
@ikGrayScale := GetProcAddress(hCIKHandle,'ikGrayScale');
@ikIncreaseColors := GetProcAddress(hCIKHandle,'ikIncreaseColors');
@ikInit := GetProcAddress(hCIKHandle,'ikInit');
@ikLoad:= GetProcAddress(hCIKHandle,'ikLoad');
@ikLoadCallback := GetProcAddress(hCIKHandle,'ikLoadCallback');
@ikLoadCursor := GetProcAddress(hCIKHandle,'ikLoadCursor');
@ikLoadPegasus := GetProcAddress(hCIKHandle,'ikLoadPegasus');
@ikLoadPal := GetProcAddress(hCIKHandle,'ikLoadPal');
@ikMaskCopy := GetProcAddress(hCIKHandle,'ikMaskCopy');
@ikMatrixFilter := GetProcAddress(hCIKHandle,'ikMatrixFilter');
@ikMirror := GetProcAddress(hCIKHandle,'ikMirror');
@ikNegate := GetProcAddress(hCIKHandle,'ikNegate');
@ikOptimizePal := GetProcAddress(hCIKHandle,'ikOptimizePal');
@ikRect := GetProcAddress(hCIKHandle,'ikRect');
@ikReduceColors := GetProcAddress(hCIKHandle,'ikReduceColors');
@ikReduceColorsCallback := GetProcAddress(hCIKHandle,'ikReduceColorsCallback');
@ikRemapPal := GetProcAddress(hCIKHandle,'ikRemapPal');
@ikRePos := GetProcAddress(hCIKHandle,'ikRePos');
@ikRotate := GetProcAddress(hCIKHandle,'ikRotate');
@ikRoundRect := GetProcAddress(hCIKHandle,'ikRoundRect');
@ikPie := GetProcAddress(hCIKHandle,'ikPie');
@ikPolygon := GetProcAddress(hCIKHandle,'ikPolygon');
@ikPolyLine := GetProcAddress(hCIKHandle,'ikPolyLine');
@ikPutScanLine := GetProcAddress(hCIKHandle,'ikPutScanLine');
@ikScreenToImageX := GetProcAddress(hCIKHandle,'ikScreenToImageX');
@ikScreenToImageY := GetProcAddress(hCIKHandle,'ikScreenToImageY');
@ikSetPalColor := GetProcAddress(hCIKHandle,'ikSetPalColor');
@ikSetScreenPal := GetProcAddress(hCIKHandle,'ikSetScreenPal');
@ikSharpen := GetProcAddress(hCIKHandle,'ikSharpen');
@ikSoften := GetProcAddress(hCIKHandle,'ikSoften');
@ikStore := GetProcAddress(hCIKHandle,'ikStore');
@ikStorePal := GetProcAddress(hCIKHandle,'ikStorePal');
@ikTextDraw := GetProcAddress(hCIKHandle,'ikTextDraw');
@ikVerify := GetProcAddress(hCIKHandle,'ikVerify');
@ikView := GetProcAddress(hCIKHandle,'ikView');


end.
