{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}
{Clone form}
unit Uclone;

{This Unit goes with Form Name 'Clone'.  Clone is intended for 24 Bit Images without
alteration.  8 Bit Images that are palettised will have to be Mapped to the same palette
prior to Using this Function}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons, VBXCtrl, Ikdsp16, StdCtrls, Menus,
  Spin;

type
  TClone = class(TForm)
    GroupBox1: TGroupBox;
    PicBuf1: TPicBuf;
    Grabclonesource: TSpeedButton;
    Exitclone: TSpeedButton;
    PopupMenu1: TPopupMenu;
    PinDisplaytoForeground: TMenuItem;
    PinDisplaytoBackground: TMenuItem;
    Bevel1: TBevel;
    Clonewidth: TLabel;
    Cloneheight: TLabel;
    Widthadjust: TSpinButton;
    Heightadjust: TSpinButton;
    Label1: TLabel;
    Label2: TLabel;
    cloneoptions: TRadioGroup;
    PaletteMapper: TSpeedButton;
    sendclonetomain: TSpeedButton;
    clonetoggle: TSpeedButton;
    cloneselect: TSpeedButton;
    Clonearea: TLabel;
    procedure GrabclonesourceClick(Sender: TObject);
    procedure PinDisplaytoForegroundClick(Sender: TObject);
    procedure PinDisplaytoBackgroundClick(Sender: TObject);
    procedure ExitcloneClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
    procedure WidthadjustDownClick(Sender: TObject);
    procedure WidthadjustUpClick(Sender: TObject);
    procedure HeightadjustDownClick(Sender: TObject);
    procedure HeightadjustUpClick(Sender: TObject);
    procedure sendclonetomainClick(Sender: TObject);
    procedure clonetoggleClick(Sender: TObject);
    procedure PicBuf1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PicBuf1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PicBuf1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cloneselectClick(Sender: TObject);
    procedure PicBuf1Paint(Sender: TObject);
    procedure PaletteMapperClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{We Define Variables required by this Unit Here. Although they are in theory available
to any Unit Refering to this Unit}
var
  Clone: TClone; {Form Name is set to Clone}
  MyCloneHDC: THandle;{Used for selection area in clone buffer}
  Clone_select : Boolean;{Used in select clone area function, True/False Flag}

implementation

Uses Udisplay,IKcon16,Uglobvar,Umaster;{Refer to required Units}

{$R *.DFM}

{'Load' an Image to Clone Buffer. This functions Transfers the Active Child to the Clone
Unit, if a Valid Child is Displayed. Note: The Clone effect is effected by the Settings
of the Picbuf. For Clone to Work As expected Assignmode should be Resize Composite and
Resize Mode should be Resample Varaible Ratio.  This allows the Image Clone Source to
be Forced into the Destination Images Selection Area. Clone is based on CopySelection
Area to Selection Area}
procedure TClone.GrabclonesourceClick(Sender: TObject);
begin
try
If Application.Mainform.MDIchildcount = 0 then Exit;
With Application.Mainform.ActiveMDIchild as TDisplay do {Refer to Active Child 'DISPLAY'}
begin
Ikassign(Clone.Picbuf1.ctl,0,Picbuf1.ctl,0); {Copy Image Accross - refer to CLONE Display}
{Prompt user if Resize / Assign mode is not correct}
case Picbuf1.Resizemode of
0..1: MessageDlg('Caution:- Destination Image "ResizeMode" Should be Set to a "Resample" Option.', mtInformation,
[mbOk], 0);
end;
case Picbuf1.Assignmode of
0..2: MessageDlg('Caution:- Destination Image "AssignMode" Should be Set to "Resize Composite" Option.', mtInformation,
[mbOk], 0);
end;
end;
{By default set area to full area on image load. Since we used a With Application Loop we
Only need refer to the Original Picbuf Name when the Display form was designed}
Picbuf1.Selecttop := 0;
Picbuf1.Selectleft := 0;
Picbuf1.SelectHeight := Picbuf1.Yresolution;
Picbuf1.Selectwidth := Picbuf1.Xresolution;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Force form to stay on top - force to Stay On Top}
procedure TClone.PinDisplaytoForegroundClick(Sender: TObject);
begin
Clone.Formstyle := fsstayontop;
Pindisplaytobackground.Checked := False;
Pindisplaytoforeground.Checked := True;
end;

{Let form go to Back - remove Stay on Top Status}
procedure TClone.PinDisplaytoBackgroundClick(Sender: TObject);
begin
Clone.Formstyle := fsnormal;
Pindisplaytobackground.Checked := True;
Pindisplaytoforeground.Checked := False;
end;

{If the Form is closed via the Exit Button Clear the Buffer and Exit the Form}
procedure TClone.ExitcloneClick(Sender: TObject);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
Clone.Hide;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Set options on close - this Clears the Buffer if Windows terminates the Form. The Clone
Function is also reset. Again we use the MouseOption Parameter to hold the requirded function,
this is used by the MouseMove Events in Both the Child Display and Clone Display Picbufs}
procedure TClone.FormClose(Sender: TObject; var Action: TCloseAction);
begin
try
{Make sure Mouseoption Clnoe is cancelled when form closes}
Mouseoption := 'Q';
Ikclear(Picbuf1.Ctl);{Empty Buffer}
If Clone_select = True then {Turn of Select function on Close}
begin
Clone_select := False;
Picbuf1.Cursor:= 1;{Disable Clone Cursor restore Normal Pick}
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Hide form & clear buffer if form is Hidden by any Method}
procedure TClone.FormHide(Sender: TObject);
begin
try
Mouseoption := 'Q'; {Reset Mouse}
Ikclear(Picbuf1.Ctl);{Kill Image}
Picbuf1.Cursor:= 1;{disable Clone Cursor restore Normal Pick}
Clone.Hide; {Hide Form}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Adjust Width value of Selection Area - Down Click. The Height and Width of Selection
area is used for Selecting the Size of the 'Brush' or Clone Area. If Fixed Area Clone
is Selected then it is Only Used for Destination Area.}
procedure TClone.WidthadjustDownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Clonewidth.Caption);
Value:= Value-1;
if Value < 1 then value := 1;
Clonewidth.Caption := Inttostr(Value);
end;

{Adjust Width value - Up Click}
procedure TClone.WidthadjustUpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Clonewidth.Caption);
Value:= Value+1;
if Value > 500 then value := 500;
Clonewidth.Caption := Inttostr(Value);
end;

{Adjust Height value of Selection Area - Down Click}
procedure TClone.HeightadjustDownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Cloneheight.Caption);
Value:= Value -1;
if Value < 1 then value := 1;
Cloneheight.Caption := Inttostr(Value);
end;

{Adjust height value - Down Click}
procedure TClone.HeightadjustUpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Cloneheight.Caption);
Value:= Value +1;
if Value > 500 then value := 500;
Cloneheight.Caption := Inttostr(Value);
end;

{Send clone Image to Mainscreen}
procedure TClone.sendclonetomainClick(Sender: TObject);
begin
try
If Application.Mainform.MDIChildcount = 0 then Exit;
With Application.Mainform.ActiveMDIchild as TDisplay do
begin
IkAssign(Picbuf1.Ctl,0,Clone.Picbuf1.Ctl,0);
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Toggle 'Clone' function on/off. Alter Cursor Accordingly - Main Child Display Knows to
select the Correct Cursor. Any Button that Activates the Function Toggles the Function
On and Off and sets the Required Cursor}
procedure TClone.clonetoggleClick(Sender: TObject);
begin
If Mouseoption = 'C' then {If Already Set then Cancel}
begin
Mouseoption := 'Q'; {No Function}
Clone.Picbuf1.Cursor := 1;{Normal Pick Cursor}
end
else
begin
MouseOption := 'C'; {Set Mouseoption to 'C' which means clone}
Clone.Picbuf1.Cursor := 5; {Select Clone Cursor}
end;
end;

{The Clone Picbuf Mouse Down Event is Used Only to define a Selection Area. Mousedownx and
Mousedowny are globals used in a few Mouse Down Events. They are Normally used to Keep
track of where the User first Clicked the Mouse Pointer on the Image}
procedure TClone.PicBuf1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
try
with sender do {Reference Sending picbuf by this method.}
begin
If Picbuf1.Contents <> 1  then Exit;{If Buffer is empty Abort}
{Set Globals to Mouse Location in Pixels}
Mousedownx := X;
Mousedowny := Y;
{Do we require a DContext for Graphics? - Clone_Select true = 'yes'
ie - Draw Selection Box. If the Clone-Select Function flag is True and the User is Using the
Left Mouse Button then we Get a Handle to a Device Context so we can Draw the Selection
area on the Image - DO NOT USE PICBUF1.HDC this causes problems. Clone Select is a
True/False Flag Defined in this Unit Above. Fixed Source Area is defined with this function}
 if Clone_select = true then {We Want a Selection Area}
  begin
    If Button = mbLeft then  {Left Button only}
    MyCloneHDC := GetDC(Picbuf1.Handle);{Get a Device Context use API call}
  end;
 end;
 except
     on E: EVBXError do
     MessageDlg('Graphics Function Error - Error Code :'
     + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
   end;
 end;

{Mouse MOve Sub for the Clone Preview Image is Only Used for Drawing Selection Areas if
the Select Function Has been enabled. Mouse X,Y location is Given on the Masterforms bottom
Display Window Bar. AreaSelection is a Global Defined in Uglobvar - its a TRECT structure}
procedure TClone.PicBuf1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
 begin
 try
  with sender do {Use this to Focus on Control}
  begin
  If Picbuf1.Contents <> 1  then Exit;{If Buffer is empty Abort}
  {Mouse Location In Pixels Display in Caption Bar of Masterform}
  Masterform.Mouse.Caption := 'X: ' + Inttostr(IKScreenToImageX(Picbuf1.ctl,X)) +
  ' Y:' + Inttostr(IKScreenToImageY(Picbuf1.ctl,Y));
   if Clone_select = true then {Is Selection Flag Enabled}
    begin
       If ssLeft in Shift then {User Must Hold Left Mouse Button}
       begin {Button hold loop sizing area}
        {Area Selection is a Trect Structure refer to Mouse down Call for start location}
        Drawfocusrect(MyCloneHDC,Areaselection);{Start Selection Box use HDC created under Mousedown}
        Areaselection.Top := Mousedowny; {Mouse Start Location Y}
        Areaselection.Left := Mousedownx;{Mouse Start Location X}
        Areaselection.Right := X;{Current Mouse Location X}
        Areaselection.Bottom := Y;{Current Mouse Location Y}
        Drawfocusrect(MyCloneHDC,Areaselection);{Erase Selection Box by recalling same area}
        {Update Selection Caption - leave Negative Values}
        Clonearea.Caption := ' Top: ' +  InttoStr(Areaselection.Top) + ' Left: ' + InttoStr(Areaselection.Left)
        +  ' Height: ' + InttoStr((Areaselection.Bottom - Areaselection.Top))+ ' Width: '
        + InttoStr((Areaselection.Right - Areaselection.left));
       end;{End Button Hold Loop sizing area}
    end;
  end;
  except
     on E: EVBXError do
     MessageDlg('Graphics Function Error - Error Code :'
     + E.Message, mtInformation,
     [mbOk], 0);
      else
      MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
      [mbOk], 0);
    end;
  end;

{After a Select Event we need to Restore the Clone True/False Cursor style to the Values
they were at before the Select function was called. We Must Also Kill the Device
context we created to draw the Rectangle. Only Kill it if it had been created in the
first place ie if Clone_Select was True}
procedure TClone.PicBuf1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
Temp:Integer;
 begin
 try
  with Sender do {Refer to Picbuf by this Means}
   begin
   If Picbuf1.Contents <> 1  then Exit;{If Buffer is empty Abort}
     If Button = mbRight then Exit;{Only Peform below on left button up}
     If Clone_select = true then {Select had been enabled}
     begin
     Drawfocusrect(MyCloneHDC,Areaselection);{Erase Last Area}
     ReleaseDC(Picbuf1.Handle,MyCloneHDC);{Destroy Device context - we Must do this}
     {Check to see Mouse Drag Direction and alter accordingly- The Selection area must
     always be defined correctly - bear in Mind that the User Can define areas by moving the
     mouse in a number of Directions:- Note at Present the user only see a Area Selection
     if the Mouse is Moved in a Top to Bottom / Left/Right Direction. Win95 Users only see
     it in a TopLeft to Lower right Selection Area - although in all cases the Area
     is correctly set:- Users Must add there own code to the DrawFocusRect call to swap
     the Tops/Bottoms Correctly - like the code used below that makes sure the Area
     Selection is Always Correct.}

     {First Check if Bottom Value is less than Top Value make Top and Bottom Swap Values-
     This occurs if the mouse was dragged from the bottom of an image up the way -
     <<Nothing required for a Left to Right / Top to Bottom Drag>>}
     If AreaSelection.Top  > AreaSelection.Bottom then
      Begin
       Temp := AreaSelection.top; {Temp Storage}
       AreaSelection.Top := AreaSelection.Bottom; {Swap}
       AreaSelection.Bottom := Temp;{Swap}
      end;
 {Check Left and Right Swap if Left Value > Right Value-This occurs if the Mouse was Dragged
 Right to Left}
     If AreaSelection.Left > AreaSelection.Right then
      Begin
       Temp := AreaSelection.Left;
       AreaSelection.Left := AreaSelection.Right;  {Swap}
       AreaSelection.Right := Temp; {Swap}
      End;

 {Calculate Width and Height of Area in Pixels}
     Selectionwidth := AreaSelection.Right - AreaSelection.Left;
     Selectionheight := AreaSelection.Bottom - AreaSelection.Top;

 {Assign Values to Picbuf Control - Convert to Image Realative Pixels for Zoomed Images}
     Buffertop:= IkScreentoImageY(Picbuf1.Ctl,AreaSelection.Top);
     Bufferleft:= IkScreentoImageX(Picbuf1.Ctl,AreaSelection.Left);
     Bufferheight:= IkScreentoImageY(Picbuf1.Ctl,Selectionheight);
     Bufferwidth:= IkScreentoImageX(Picbuf1.Ctl,SelectionWidth);

 {Check No Negative Values}
    If Buffertop < 0 then Buffertop:= Buffertop * -1;
    If Bufferleft < 0 then Bufferleft:= Bufferleft * -1;
    If Bufferheight < 0 then Bufferheight:= Bufferheight * -1;
    If Bufferwidth < 0 then Bufferwidth:= Bufferwidth * -1;

 {Set Selection Area after all Checks}
    Picbuf1.Selecttop := Buffertop;
    Picbuf1.SelectLeft := Bufferleft;
    Picbuf1.SelectHeight := Bufferheight;
    Picbuf1.SelectWidth := Bufferwidth;

 {Update status Caption for area selection}

 Clonearea.Caption := ' Top: ' + InttoStr(Picbuf1.Selecttop) + ' Left: ' + InttoStr(Picbuf1.Selectleft)
 +  ' Height: ' + InttoStr(Picbuf1.SelectHeight) + ' Width: ' + InttoStr(Picbuf1.Selectwidth);


{Reset Area Selection}
    AreaSelection.Top := 0;{Reset Area Rect to 0,0}
    AreaSelection.Left := 0;
    AreaSelection.Right:=0;
    AreaSelection.Bottom:=0;

 {Disable Clone Function Reset Flags/cursors. If when the Select Function was enablded the Clone
 function was active make sure we restore the Clone Cursor not a default Cursor. To do this
 check the MouseOption Flag}
    Clone_select := False;
    Case MouseOption of {Clone Function is Active therefore restore Cursor 5 clone}
    'C':Picbuf1.Cursor:= 5;{Enable Clone Cursor - default for this form}
    else
    Picbuf1.Cursor:= 1; {Clone Function was not Active, restore normal Cursor}
    end;
    Popupmenu.Autopopup:=True;{enable Popup menu when area selection disabled}
    end;
  end;
 except
     on E: EVBXError do
     MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
     + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
   end;
  end;


{Enable/Disable Clone selection area function - alter Cursor Accordingly}
{Do not enable if no image exists. Alter Cursor to Suit function set before
select was called ie was clone enalbled or Not}
procedure TClone.cloneselectClick(Sender: TObject);
begin
If Clone_select = True then
begin
Clone_select := False;
Popupmenu.Autopopup:=True;{enable Popup menu when area selection disabled}
Case MouseOption of
'C': Picbuf1.Cursor := 5;{Restore Clone Cursor If clone was Already active}
else
Picbuf1.Cursor := 1;{Normal Pick - Clone was not Active}
end;
end
else
begin
Picbuf1.Cursor:= 3;{Enable Select Cursor}
Clone_select := True;
Popupmenu.Autopopup:=False; {Disable form Popup menu when area selection enabled}
end;

If Picbuf1.Contents <> 1 then {If no Image exist then make select false}
begin
Clone_select := False;
Picbuf1.Cursor:= 1;{Enable normal Cursor - default for this form}
MouseOption:= 'Q';{Turn Off Clone Function}
Popupmenu.Autopopup:=True;{Enable Popup menu when area selection disabled}
end;
end;

{Update Area Selection Caption}
procedure TClone.PicBuf1Paint(Sender: TObject);
begin
Clonearea.Caption := ' Top: ' + InttoStr(Picbuf1.Selecttop) + ' Left: ' + InttoStr(Picbuf1.Selectleft)
+  ' Height: ' + InttoStr(Picbuf1.SelectHeight) + ' Width: ' + InttoStr(Picbuf1.Selectwidth);
end;


{For 8 Bit Images any Copy/Select functions will have Bizarre effects Unless
both Images have the Same Palette. Map Active Child to Clone Preview Image. Clipboard
Copy Paste Function have the Same drawbacks with 8 Bit Images}
procedure TClone.PaletteMapperClick(Sender: TObject);
begin
try
If Application.Mainform.MDIChildCount = 0 then Exit;
If Clone.Picbuf1.Contents <> 1 then Exit;{No Image}
If Clone.Picbuf1.ColorDepth > 8 then Exit;{No Palette}
With Application.Mainform.ActiveMDIchild as TDisplay do
Begin
If Picbuf1.Contents <> 1 then Exit;{No Image}
If Picbuf1.Colordepth > 8 then Exit;{No Image}
ikDitherpal(Picbuf1.ctl,Clone.Picbuf1.ctl);
end;
except
     on E: EVBXError do
     MessageDlg('Graphics Function Error - Error Code :'
     + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
   end;
end;

end.
