{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.
ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}



unit Uglobals;

{Global Functions can be called anywhere. There is No Connected Form. I have put functions
that are not straight 'Knife Functions' in this Module. Most of the Variables used are
defined in the UGlobvar Unit}

interface

Uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,  ExtCtrls, VBXCtrl,StdCtrls,IKcon16,Chartfx;

{Put all Procedures here to make them global. Procedure have been given Names Reflecting
there Functions}

{Call the Load and Create a child window in Masterform Unit1}
     procedure Callmasterformload;
{Generate a Histogram on Current Active Window 8 Bit}
     procedure Createhistogram8bit;
{Generate a Histogram on Current Active Window 24 Bit}
     procedure Createhistogram24bit;
{Generate a New Child window with a Red Channel Only Image - 24Bit source}
     procedure Createredchannel;
{Generate a New Child window with a Green Channel Only Image - 24Bit source}
     procedure Creategreenchannel;
{Generate a New Child window with a Blue Channel Only Image - 24Bit source}
     procedure Createbluechannel;
{Generate a Palette Grid of Image Colors if available}
     procedure CreatePalette;
{Replace a specific Palette Color}
     procedure Colorpalettereplace(ColorValue: Longint; Palettelocation : Integer);
{Insert Text to Image}
     Procedure Inserttext;
{Combine 24 Bit RGB Channels}
     Procedure Combine24bit;
{Resize an Image}
     Procedure Resizeimage;
{Tune RGB Levels}
     Procedure Rgbtune(Channel: Char);
{Alter Brightness/Contrast}
     Procedure PBrightness;
{Alter Brightness/Contrast}
     Procedure PContrast;

     implementation
 {Use the Followinf Forms}
     Uses Umaster,Udisplay,Uglobvar,UHist,Ubackgnd,UPref,Upalette,UText,Uresize,Utint,Utune;

{Call the Load and Create a child window in Masterform Unit1. We Simulate a Click Event
from the MainMenu Loadfile Menu Item}

     procedure Callmasterformload;
     begin
     Masterform.LoadFile1Click(Masterform);
     end;

{Generate a Histogram on Current Active Window:-
This Version For 8Bit Images Only based on Palette Index Occurence. In other Words we
study each Pixel in turn, find out the Palette index it has and keep track of the Number
of Pixels that have the same Palette Index. The Result is the Plotted using the Chartfx
Control. Plotted Values are Palette index Location 0 to 255 on the X Axis and the Y scale
Plots the Total Number Of Pixels at Each Palette Location}

    procedure Createhistogram8bit;

    {Set up arrays}
    {Set up variables - some based on Globvar Unit declarations}

Var
     Scandata: Scandataarray;{Used to Hold Image Data - we must always pass a Pointer - Array}
     I, J , Xres, Yres : Integer;{Hold Picture Resolutions}
     Picarray : array[0..255] of Longint;{Tally of Palette values - Array}

begin
 try
 {Set all array elements to 'zero' - Possible 256 ie 0 to 255}
   For I := 0 to 255 do
     Picarray[I]:=0;

     {Refer to main Active Child display using do loop}
with Application.Mainform.ActiveMDIChild as TDisplay do
 begin
  {check resolutions of display and Store Values}
  Xres := Picbuf1.Xresolution;
  Yres := Picbuf1.Yresolution;

  {Catch any Image that exceeds spec of handler 1800 pixels wide Y-res does not Matter.
  With Delphi we must Pre Define the Array Size so we set a Limit that must not be past.}
  If Xres >= 1800 then {Display Dialogue if Image exceeds our Limit - Uglobvar sets this Limit}
   begin
   MessageDlg('Image X-Resolution must be less than 1800 Pixels.', mtInformation,
   [mbOk], 0);
   Exit;{Cancel Sub}
   end;

 {Scan Image for Data - We Use two Arrays 1 Stores Each line Another Holds Tally of
 Pixel Values. The principle is to scan 1 line, look at each pixel and add 1 to that pixels
 palette location to the eqivelent position in a second array - picarray- this
 in effect does our addtion of pixels with the same palette Index. }
  For I := 0 to (Yres - 1) do {Scan Image Top to Bottom}
  begin {Start Scan Loop}
  Screen.Cursor:= 4;  {Show bit Wait Cursor}
  Ikgetscanline (Picbuf1.ctl, I, @Scandata); {Scan Image Line I}
   For J := 1 to Xres do {Scan Across Every Pixel Tallying Pixel Palette Locations}
     {}
     {At this Stage 'Scandata' holds the Palette Index for each Pixel on that line.
     ScanData Array elements can have a range of possible values 0 to 255. We use the value
     of each array element to locate the Position within Picarray. Picarray is 0 to 255
     elements in length. We add 1 to Picarray each time Scandata Array is of a equal value.
     This has the effect of totalising the number of occurences of a Palette index within
     an Image - It is easier then It sounds :-!}
     (Picarray[Scandata[J]]) := (Picarray[Scandata[J]]) + 1;{Add 1 each time}
   end; {End Line Across Scan}
  end; {End Down Image Scan}

  {For Example Take an Image that is 256 Pixels accross (XRES)and 2 Lines long (YRES).
  Assume Each Pixel on the First & Second Line Has a different Palette Location.
  Pixel 1 in the Line 1 has Palette Index 0, Pixel 2 has Palette Index of 1 and so on up
  to Pixel 256 having Palette value 255- ( Note:- the Values Do differ By 1 the For I and For
  J loops start at 0 and 1 to allow for this ).

  The above Function would Scan the Ist Line, and add 1 to Every Element
  of Picarray. When the Above Function Moved down to the Second Line another 1 would be added
  to every element of PicArray - Each Element of PicArray would Now Contain 2. Thus we sum the
  values in this example 2 Pixels have palette Location 0 - Pixel Number 1 of Lines 1 and 2.
  If every Pixel had a Palette loaction of 0 - Then Only Picarray element 0 would have a value
  in this case 256 * 2 - ie the total Number of Pixels in the Image. It is then easy to use
  this Picarray to Plot a Graph}

 {Refer to Histogram screen - doing this we then do not have to refer to it Again}

 With Histogram do {Histogram is the Name of the Form Containing the Graph Control Unit Uhist}
  Begin
  Graph.OpenData[COD_VALUES]:=MAKELONG(1,256);{Tell Graph we are Plotting 1 Set of 256 Points}
  Graph.Thisserie:=0;{Define This series as 0}
  {Use Loop to Move Pointer for plotting Points - 255 for 256 palette positions - Auto Inc must be false}
  For I :=  0 to 255 do
    begin
    Graph.Value[I]:= Picarray[I]; {Plot Points based on the Array pass I to access correct Location}
    end;
    Graph.CloseData[COD_VALUES]:=0;{Close Graph Data Channel}
  end;
  Histogram.Show;{Show Form}
  Screen.Cursor:= crDefault;  {Show default Cursor on Completion}
   except
     on E: EVBXError do  MessageDlg('Histogram Error - ' + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('System Error.', mtInformation,
     [mbOk], 0);
   end;
  end;



 {Create Histogram of 24 Bit Image. The Principle is the Same as Above. We need to do it
 3 times as we Split the Image up into the RGB Channels. We Again scan every Pixel. Get each
 Pixels Value in Long format, we then split this into a Red, Green and Blue Value. Like
 Palette values the possible values obtained are 0 to 255. 3 Arrays tally values, then the
 arrays are used to plot the Graph}

 procedure Createhistogram24bit;{Must be 24 Bit}

 {Set up variables}

 Var
 Scandata: Scandataarray;{Used to Hold Image Data}
 I, J , Xres, Yres, Red, Green, Blue : Integer;{Hold Picture Resolutions etc}
 Redarray : array[0..255] of Longint;{Tally  Red values}
 Greenarray : array[0..255] of Longint;{Tally Green values}
 Bluearray : array[0..255] of Longint;{Tally Blue values}

 begin
 try
 {Set all Arrays to Zero}
 For I := 0 to 255 do
  Begin
  Redarray[I]:=0;
  Greenarray[I]:=0;
  Bluearray[I]:=0;
  end;


  {Refer to main Active display}

 with Application.Mainform.ActiveMDIChild as TDisplay do {Refer to Display}
  begin
  {Check resolutions of display}
   Xres := Picbuf1.Xresolution;
   Yres := Picbuf1.Yresolution;

   {Catch any Image that exceeds spec of handler 1800 pixels wide}
  If Xres >= 1800 then
   begin
   MessageDlg('Image X-Resolution must be less than 1800 Pixels.', mtInformation,
   [mbOk], 0);
   Exit;{Cancel Sub}
   end;
 For I := 0 to (Yres-1) do {Start Image Scan}
  begin
   Screen.Cursor:= 4;  {Show bit Wait Cursor}
   Ikgetscanline (Picbuf1.ctl, I, @Scandata); {Get Line Data from Y Scan line Number I}
   For J := 0 to Xres do {X Scan - Scan Accross Image - once per line}
    begin
    Red := GetRValue(Scandata[J]); {Get Pixels Red Value - use value in Tally Operation}
    Green := GetGValue(Scandata[J]);{Get Pixels Green Value - use value in Tally Operation}
    Blue := GetBValue(Scandata[J]);{Get Pixels Blue Value - use value in Tally Operation}
    (Redarray[Red]) := (Redarray[Red]) + 1; {Tally = Values}
    (Greenarray[Green]) := (Greenarray[Green]) + 1;{Tally = Values}
    (Bluearray[Blue]) := (Bluearray[Blue]) + 1;{Tally = Values}
    end;{Scan Across Image Loop}
   end;{Scan Down Image Loop}
  end;{End Loop for Active Display}


  {Use Form Tags to check and see if display holds only 1 color Channel
  if it does only plot that channels value. See Red Channel Image Creation Below}
  Histogram.Graph.OpenData[COD_VALUES]:=MAKELONG(3,256);{3 Data sets this time R,G,B}
  Histogram.Graph.Thisserie:=0; {Set Graph to First Data Set}
 For I :=  0 to 255 do {Plot Red only}
 begin
  If Application.Mainform.ActiveMDIchild.Tag = 2 then Redarray[I] := 0;{Force Values to 0}
  If Application.Mainform.ActiveMDIchild.Tag = 3 then Redarray[I] := 0;{Force Values to 0}
  Histogram.Graph.Value[I]:= Redarray[I]; {Plot Points}
  end;

   Histogram.Graph.Thisserie:=1;{Set Graph to Second Data Set}

 For I :=  0 to 255 do {Plot Green only}
  begin
   If Application.Mainform.ActiveMDIchild.Tag = 1 then Greenarray[I] := 0;{Force Values to 0}
   If Application.Mainform.ActiveMDIchild.Tag = 3 then Greenarray[I] := 0;{Force Values to 0}
   Histogram.Graph.Value[I]:= Greenarray[I]; {Plot Points}
  end;

  Histogram.Graph.Thisserie:=2; {Set Graph to third Data Set}

 For I :=  0 to 255 do {Plot Blue only}
  begin
   If Application.Mainform.ActiveMDIchild.Tag = 1 then Bluearray[I] := 0;{Force Values to 0}
   If Application.Mainform.ActiveMDIchild.Tag = 2 then Bluearray[I] := 0;{Force Values to 0}
   Histogram.Graph.Value[I]:= Bluearray[I]; {Plot Points}
  end;

  {Paint Graph the Correct colors to Refelct the RGB Channels}
     Histogram.Graph.CloseData[COD_VALUES]:=0;
     Histogram.Graph.OpenData[COD_COLORS]:=3;
     Histogram.Graph.Thisserie:=0;
     Histogram.Graph.Color[0] := Rgb(255,0,0);
     Histogram.Graph.Thisserie:=1;
     Histogram.Graph.Color[1] := Rgb(0,255,0);
     Histogram.Graph.Thisserie:=2;
     Histogram.Graph.Color[2] := Rgb(0,0,255);
     Histogram.Graph.CloseData[COD_COLORS]:=0; {Terminate Data transfer and create Graph}
     Histogram.Caption := '24 Bit';
     Histogram.Show;
     Screen.Cursor:= crDefault;  {Show Default Cursor}
  except
  on E: EVBXError do  MessageDlg('Histogram Error - ' + E.Message, mtInformation,
  [mbOk], 0);
     else
     MessageDlg('System Error.', mtInformation,
     [mbOk], 0);
     end;
  end;

  {Create a new Image with a Redchannel only set created forms tag to RED. Similar to the
  techniques above. We Create a New Image to Hold the New Channel. We then Scan the RGB 24
  bit Image 1 Line at a Time and Subtract the Red Content from every Pixel. We then place the
  Red value into a New Image at the Same Pixel Location, but we set the Pixels Green and
  Blue Values to 0. We thus create a Red Channel Image Only. We assign a value of 1 to the new Forms
  tag Property. This is so the Histogram Graph Plot routine does not Plot Values for the
  Green or Blue component.}

  procedure Createredchannel;
  var
  RedDisplay : TDisplay; {Reference our Display}
  Copyreddata: Scandataarray; {Set Up arrays to hold Data Scan Transfer - Defined in Uglobvar}
  Redchanneldata: Scandataarray;
  I,J,Redvalue: Integer;
   begin
    try
     With Application.Mainform.Activemdichild as TDisplay do {Refrence Main Display}
      begin
      Screen.Cursor:= 4;  {Show bit Wait Cursor}
      RedDisplay := TDisplay.Create(Application);{Create New Display AFTER Referencing MAIN DISPLAY}
     {Set various modes depending on Preferences selected}
      RedDisplay.Tag:= 1;{Set Forms Tag to 1 meaning 'Red Channel'}
      RedDisplay.Picbuf1.Assignmode := Preferences.Displayassignmode.Itemindex;

      Case Preferences.Displayautoscale.Itemindex of
       0: RedDisplay.Picbuf1.Autoscale := False;
       1: RedDisplay.Picbuf1.Autoscale := True;
      end;

      Case Preferences.DisplayAutosize.Itemindex of
       0: RedDisplay.Picbuf1.Autosize := False;
       1: RedDisplay.Picbuf1.Autosize := True;
      end;

       RedDisplay.Picbuf1.Resizemode := Preferences.Displayresizemode.Itemindex;

       {Prepare new display- Must Do this prior to Using it}
       Ikinit(RedDisplay.Picbuf1.ctl,24,Picbuf1.Xresolution,Picbuf1.Yresolution,
       RGB(0,0,0));

 {Start DataScan of Active Child Display}
 For I := 0 to (Picbuf1.Yresolution - 1) do {Down Image Scan Loop}
  begin
   Ikgetscanline(Picbuf1.ctl,I,@Copyreddata);{Get Line Data place in array}
    For J:= 1 to Picbuf1.Xresolution do {Scan each pixel in line}
     begin
     Redvalue:= Getrvalue(Copyreddata[J]);{Get Red Value of Each Pixel in line}
     Redchanneldata[J]:=RGB(Redvalue,0,0);{Create New 'Red Pixel' Value and assign to New Array}
     end; {end of scan across loop}
    Ikputscanline(Reddisplay.Picbuf1.ctl,I,@Redchanneldata);{Transfer New Line of Red Data to
    new Image.}
    end;{End of Line Scan Loop}
    RedDisplay.Caption:= 'Red Channel Data';
    RedDisplay.Show;{Show new Image}
    Screen.Cursor:= crDefault; {Show Default Cursor}
  end;
  except
     on E: EVBXError do  MessageDlg('Red Channel Error - ' + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('Red Channel System Error.', mtInformation,
     [mbOk], 0);
     end;
  end;

  {Create a Green Channel Image - As Above }
  procedure Creategreenchannel;
  var
  GreenDisplay : TDisplay;
  Copygreendata: Scandataarray;
  Greenchanneldata: Scandataarray;
  I,J,Greenvalue: Integer;
  begin
   try
    With Application.Mainform.Activemdichild as TDisplay do
     begin
      Screen.Cursor:= 4;  {Show bit Wait Cursor}
      GreenDisplay := TDisplay.Create(Application);{Create New Display}
      GreenDisplay.Tag := 2;{Set tag to 2 = Green}
      {   Set various modes depending on Preferences selected}

       GreenDisplay.Picbuf1.Assignmode := Preferences.Displayassignmode.Itemindex;

       Case Preferences.Displayautoscale.Itemindex of
       0: GreenDisplay.Picbuf1.Autoscale := False;
       1: GreenDisplay.Picbuf1.Autoscale := True;
       end;

       Case Preferences.DisplayAutosize.Itemindex of
       0: GreenDisplay.Picbuf1.Autosize := False;
       1: GreenDisplay.Picbuf1.Autosize := True;
       end;

       GreenDisplay.Picbuf1.Resizemode := Preferences.Displayresizemode.Itemindex;

       Ikinit(GreenDisplay.Picbuf1.ctl,24,Picbuf1.Xresolution,Picbuf1.Yresolution,
       RGB(0,0,0));

       {Start DataScan on Active child}
       For I := 0 to (Picbuf1.Yresolution - 1) do
       begin
       Ikgetscanline(Picbuf1.ctl,I,@Copygreendata);
        For J:= 1 to Picbuf1.Xresolution do
         begin
          Greenvalue:= Getgvalue(Copygreendata[J]);
          Greenchanneldata[J]:=RGB(0,Greenvalue,0);
         end;
        Ikputscanline(Greendisplay.Picbuf1.ctl,I,@Greenchanneldata);
        end;
      GreenDisplay.Caption:= 'Green Channel Data';
     GreenDisplay.Show;
     Screen.Cursor:= crDefault;  {Show Default Cursor}
    end;
  except
     on E: EVBXError do  MessageDlg('Green Channel Error - ' + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('Green Channel System Error.', mtInformation,
     [mbOk], 0);
     end;
  end;

  {Create a Blue Channel Image - As above}
  procedure Createbluechannel;
  var
  BlueDisplay : TDisplay;
  Copybluedata: Scandataarray;
  Bluechanneldata: Scandataarray;
  I,J,Bluevalue: Integer;
  begin
  try
   With Application.Mainform.Activemdichild as TDisplay do
    begin
     Screen.Cursor:= 4;  {Show bit Wait Cursor}
     BlueDisplay := TDisplay.Create(Application);{Create New Display}
     BlueDisplay.Tag := 3;{Set Tag to 3  = Blue}
  {Set various modes depending on Preferences selected}

     BlueDisplay.Picbuf1.Assignmode := Preferences.Displayassignmode.Itemindex;

      Case Preferences.Displayautoscale.Itemindex of
       0: BlueDisplay.Picbuf1.Autoscale := False;
       1: BlueDisplay.Picbuf1.Autoscale := True;
      end;

      Case Preferences.DisplayAutosize.Itemindex of
       0: BlueDisplay.Picbuf1.Autosize := False;
       1: BlueDisplay.Picbuf1.Autosize := True;
      end;

       BlueDisplay.Picbuf1.Resizemode := Preferences.Displayresizemode.Itemindex;

      Ikinit(BlueDisplay.Picbuf1.ctl,24,Picbuf1.Xresolution,Picbuf1.Yresolution,
      RGB(0,0,0));

  {Start DataScan on Active Child}
  For I := 0 to (Picbuf1.Yresolution - 1) do
   begin
    Ikgetscanline(Picbuf1.ctl,I,@Copybluedata);
     For J:= 1 to Picbuf1.Xresolution do
       begin
       Bluevalue:= Getbvalue(Copybluedata[J]);
       Bluechanneldata[J]:=RGB(0,0,Bluevalue);
       end;
      Ikputscanline(BlueDisplay.Picbuf1.ctl,I,@Bluechanneldata);
     end;
    BlueDisplay.Caption:= 'Blue Channel Data';
   BlueDisplay.Show;
   Screen.Cursor:= crDefault;  {Show Default Cursor}
  end;
  except
     on E: EVBXError do  MessageDlg('Blue Channel Error - ' + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('Blue Channel System Error.', mtInformation,
     [mbOk], 0);
     end;
  end;

{Create a Palette Display of active Image. Active Display must be 8 Bit.
Create a Gobal Array that has 0 to 255 elements, each element holds a palette
value.  This Array is then used by the DrawGrid Paint event to color the Display}
 procedure CreatePalette;
  begin
   try
    With Application.Mainform.ActiveMdiChild as TDisplay do {Refer to Main Display}
     Begin
      IkGetPalette(Picbuf1.ctl,@Paldata);{Get Palette Data Store in Array}
      Palette.Show; {It is the Repaint Grid Cell of Palette form [Pal unit] that uses Array above}
     end;
     except
     MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
  end;
  end;

  {Replace a Given Color Palette called from Palette form - Color and Location is passed}
  procedure Colorpalettereplace(ColorValue: Longint; Palettelocation : Integer);
  {ColorValue holds New Color and Palettelocation holds Palette location to be replaced}

  begin
  {-----Color replace section-----}
  end;

  {Display Text Form}
  Procedure Inserttext;
   begin
   Textform.show; {Show Text form Unit Utext}
   end;

  {Combine 24 Bit RGB Channels - Use Background.'RED/GREEN/BLUE BUFFERS'. The Images used
  for the Combine function are stored in the 'Background' forms 3 Image Buffers,Red, Green
  and Blue. The Principle is to add the Same Pixel in each image, to create a Full
  color Image. The Images must be 24 Bit. A New Display is created to hold the resulting
  Image. The Principle for extracting the New Pixel Data is similar to the above Histogram
  Example. All images must have the same x/y Res - user should trap for this}
  Procedure Combine24bit;
  var
  Redchannel,Greenchannel,Bluechannel,Combinechannel: Scandataarray; {Arrays to hold Data}
  I,J,Redvalue,Greenvalue,Bluevalue:Integer;{Used to temp store Pixel Data}
  Combinedisplay: TDisplay;{Create a New Display based on our Chid Display Design Form}
  Begin
  try
  With Background do
  Begin
  Screen.Cursor:= 4;  {Show bit Wait Cursor}
  Combinedisplay := TDisplay.Create(Application);{Create New Display}

{Set various modes depending on Preferences selected for created Display}

  Combinedisplay .Picbuf1.Assignmode := Preferences.Displayassignmode.Itemindex;

       Case Preferences.Displayautoscale.Itemindex of
         0: Combinedisplay .Picbuf1.Autoscale := False;
         1: Combinedisplay .Picbuf1.Autoscale := True;
       end;

       Case Preferences.DisplayAutosize.Itemindex of
         0: Combinedisplay .Picbuf1.Autosize := False;
         1: Combinedisplay .Picbuf1.Autosize := True;
       end;

       Combinedisplay .Picbuf1.Resizemode := Preferences.Displayresizemode.Itemindex;

     Ikinit(Combinedisplay.Picbuf1.ctl,24,RedBuffer.Xresolution,Background.RedBuffer.Yresolution,
     RGB(0,0,0));{Make Sure we initilize the Buffer ready to accept Data}

     {As in the Histogram examples above we scan each Buffer Image - all at once - extract
     each Pixels Value and Then Combine the Resulting Pixel values to create a New Display.
     Consider Pixel Number 1 in the New Display and Backgrounds Red, Green and Blue Display:-
     The New Pixel number 1 is made of the Red Buffers Pixels Red content, the Green Pixels Green Content
     and The Blue Pixels Blue Content}
     For I := 0 to (RedBuffer.Yresolution - 1) do {Scan all Images Top to Bottom}
       begin
        Ikgetscanline(RedBuffer.ctl,I,@Redchannel); {Get Line No I From Red Buffer}
        Ikgetscanline(GreenBuffer.ctl,I,@Greenchannel); {Get Line No I From Green Buffer}
        Ikgetscanline(BlueBuffer.ctl,I,@Bluechannel);{Get Line No I From Blue Buffer}
         For J:= 1 to Redbuffer.Xresolution do {Scan Across each Line, Pixel by Pixel}
          begin
           Redvalue:= Getrvalue(Redchannel[J]); {Get Red Content from Red Pixel Array Data}
           Greenvalue:= Getgvalue(Greenchannel[J]);{Get Green Content from Green Pixel Array Data}
           Bluevalue:= Getbvalue(Bluechannel[J]); {Get Blue Content from Blue Pixel Array Data}
           Combinechannel[J]:=RGB(Redvalue,Greenvalue,Bluevalue);{Build New Line of Pixel Data}
          end;
        Ikputscanline(Combinedisplay.Picbuf1.Ctl,I,@Combinechannel);{Place New Line In new Buffer}
        end;
       Combinedisplay.Caption:= 'RGB Merge';{Update Caption}
      Combinedisplay.Show; {Show Form}
      Screen.Cursor:= crDefault;  {Show default Cursor}
     end;
     except {Trap Errors}
     on E: EVBXError do  MessageDlg('Blue Channel Error - ' + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('Blue Channel System Error.', mtInformation,
     [mbOk], 0);
    end;
    end;

{Resize an Image - Use Background 'ScratchA' buffer. Use Options available from the Knife
Control. Display a Dialogue Box to get User Input. Form Uresize. Ask the user for a new
X / Y res. Depending on options selected the user can Sqeeze or Stretch an Image.}
    Procedure Resizeimage;
    var
    Requestedx,Requestedy: Integer; {Get User Input}
    ResizedImage: TDisplay;{Creat a New Display for New Image - Based  on Child Form}
    begin
    try
    Resize.ShowModal; {Show Dialogue box as a Modal Box - we can then use the Modal result}
    If Resize.Modalresult = mrOK then {Execute on 'OK' only - mrOK is the MODALRESULT if Ok is picked}
     begin
      With Application.Mainform.ActiveMDIchild as TDisplay do  {Focus on Main Child}
      begin
      Screen.Cursor:= 4;  {Show bit Wait Cursor}
      Requestedx := StrtoInt(Resize.NewXres.Text);{Get User Selection}
      Requestedy := StrtoInt(Resize.NewYres.Text);{Get User Selection}
      Background.Scratch.Assignmode := 0;{Use Background form for temp storage}
      ikInit(Background.Scratch.Ctl, Picbuf1.ColorDepth, Requestedx,Requestedy,clGray);{Init buffer}
      Background.Scratch.Resizemode := Resize.Modes.Itemindex;{Resample Mode - this allows user to Sretch etc}
      Background.Scratch.Assignmode := 3;{Must be Total Replacement}
      If Picbuf1.ColorDepth <= 8 then {Copy Palette accross if there is one}
         ikRemapPal (Background.Scratch.Ctl, Picbuf1.Ctl); {Do the Palette Mapping}
         ikAssign(Background.Scratch.Ctl,0,Picbuf1.Ctl,0);{DO THE RESIZING}
         ResizedImage := TDisplay.Create(Application);{Create New Display for Result}
         ResizedImage.Picbuf1.Autoscale := True; {Expand Image to Screen}
         ResizedImage.Picbuf1.Autosize :=False;
         ikAssign(ResizedImage.Picbuf1.Ctl,0,Background.Scratch.Ctl,0);{Copy Background to result Display}
         ResizedImage.Show; {Display New Image}
         ResizedImage.Caption := 'Resized Image';
         ikClear(Background.Scratch.Ctl);{Clear Buffer - saves system Resources}
         Screen.Cursor:= crDefault;  {Show default Cursor}
       end;
      end;
      except {Trap Errors}
       on E: EVBXError do  MessageDlg('Resize Error - ' + E.Message, mtInformation,
       [mbOk], 0);
       on E: EConvertError do MessageDlg('Resize Error - Non Valid User Input Values.'
       ,mtInformation,[mbOk], 0);
       else
       MessageDlg('System Error.', mtInformation,
       [mbOk], 0);
       end;
       Screen.Cursor:= crDefault;  {Show default Cursor if an error has occurded}
    end;

    {RGB Tune / TINT - Use Scroll bar values on Tune form - Channel holds requested function
    tint/tune. This Procedure is called form the Tint or Tune dialog Boxes - see Notes in Units
    Utune and Utint. Note that a Parameter is passed to the Function and Depending on the
    parameter passes a different Section of the procedure is called. The Parameter is
    assigned to the local variable Channel and is a Character type eg 'A' 'B' etc. In this case
    'C' is passed for 'Tint' Calls and 'T' and/or 'P' is passed for 'Tune' Calls - from the Tint
    and Tune Dialogue Boxes respectively. Agian the Principle is the Same as the Histogram
    and Create Channel Methods Above. We get a Pixel Value and add or add a % to it depending
    on the Calling Module. The Tint Method adds a Correction value for the given channel
    regardless if the PIXEL Contained the COLOR being Corrected or not. The Tune Module
    only adds a Value if the Pixel Contained Some of the Color in the First Place. In other
    word take a solid image that is Black. Applying a Red 'Tint' to it can TURN the IMAGE
    totally RED. If you 'Tune' the Image then you cannot add any Red to it as no Red was
    in the Image in the FIRST place. The Tune allows absolute Values or % values to be
    added. The Function always works on the Active Child Display - the Result being
    shown on the Calling forms respective Preview Window. The FUNCTION MUST HAVE AN
    ACTIVE CHILD TO WORK}
Procedure Rgbtune(Channel: Char);{Pass a value and Assign to 'Channel'}
var
ImageData: Scandataarray; {Hold OldData and NewData}
NewData: Scandataarray;{Hold OldData and NewData}
I,J: Integer; {Counters}
Redvalue,Greenvalue,Bluevalue: Integer;{Color Values}
Correctedredvalue,Correctedgreenvalue,Correctedbluevalue: Integer;{Adjusted Values}
begin
 try
  If Application.Mainform.MdiChildcount = 0 then Exit;{If no Image Abort}
  {Reference main Image - Picbuf1 can be then be used to REFER to it}
   With Application.Mainform.ActiveMDIchild as TDisplay do
    begin
     Case Channel of {Find out which Function is Required Using Case}
     'C': begin  {'C' = Tint calls called from 'Tint' or Utint Module/Form}
     Ikinit(Tint.Picbuf1.ctl,24,Picbuf1.Xresolution,Picbuf1.Yresolution,
     RGB(0,0,0)); {Init 'Tint' forms Preview Image Screen}
     For I := 0 to (Picbuf1.Yresolution - 1) do {Scan Active Child}
     begin
      Screen.Cursor:= 4;  {Show bit Wait Cursor}
      Ikgetscanline(Picbuf1.ctl,I,@Imagedata);{Get Line Data of active Child}
       For J:= 1 to Picbuf1.Xresolution do {Scan Pixels for each Line}
        begin{Scan Loop - Depending on Channel alter code}
         Redvalue:= Getrvalue(Imagedata[J]); {Get there Color Value split into RGB}
         Greenvalue:= Getgvalue(Imagedata[J]);{Get there Color Value split into RGB}
         Bluevalue:= Getbvalue(Imagedata[J]);{Get there Color Value split into RGB}
{Multiply * -1 to swap top/bottoms on scroll bars - see notes in Units Utune - Add the Scroll
bars Value to the Pixel - adding the TINT - and check the resulting value does not exceed
255 or 0}
         Correctedredvalue:= Redvalue + (Tint.Rchannel.Position * -1);{Scroll bar Setting}
         Correctedgreenvalue:= Greenvalue + (Tint.Gchannel.Position * -1);
         Correctedbluevalue:= Bluevalue + (Tint.Bchannel.Position * -1);
         if Correctedredvalue < 0 then Correctedredvalue := 0;
         if correctedredvalue > 255 then Correctedredvalue := 255;
         if Correctedgreenvalue < 0 then Correctedgreenvalue := 0;
         if correctedgreenvalue > 255 then Correctedgreenvalue := 255;
         if Correctedbluevalue < 0 then Correctedbluevalue := 0;
         if correctedbluevalue > 255 then Correctedbluevalue := 255;
         Newdata[J]:= RGB(Correctedredvalue,Correctedgreenvalue,Correctedbluevalue);
        end;  {End Scan Loop}
        Ikputscanline(Tint.Picbuf1.ctl,I,@Newdata);{Update Tint Preview Display}
       end;
       Tint.Picbuf1.Refresh; {Refresh Image In Preview Display}
       Screen.Cursor:= crDefault; {Restore Cursor}
      end;{End Tint Select}
{Second Option is to Tune Image - As above but we add values only to thoses pixels
that contained a value of the Color being added in the first place}
'T':begin {Start 'Tune' Case - called via Tune Module}
 IkInit(Tuner.Picbuf1.ctl,24,Picbuf1.Xresolution,Picbuf1.Yresolution,
 RGB(0,0,0));{Init Tunes Preview Display}
  For I := 0 to (Picbuf1.Yresolution - 1) do {Scan Active Child Display}
   begin
   Screen.Cursor:= 4;  {Show bit Wait Cursor}
   Ikgetscanline(Picbuf1.ctl,I,@Imagedata); {Scan Each Line}
    For J:= 1 to Picbuf1.Xresolution do{Scan each Pixel per Line}
     begin{Scan Loop - Depending on Channel alter code}
      Redvalue:= Getrvalue(Imagedata[J]);{Extract RGB Value - GETRVALUE is a Function CAll}
      Greenvalue:= Getgvalue(Imagedata[J]);{Green Content}
      Bluevalue:= Getbvalue(Imagedata[J]);{Blue Content}
{Multiply * -1 to swap top/bottoms on scroll bars}
{For Tune only alter Values that already had a Value ie 0,0,0 stays 0,0,0. We check the Value
obtained above and if it is 0 we do nothing to it}
      if Redvalue  > 0 then {Apply Correction}
      Correctedredvalue:= Redvalue + (Tuner.red.Position * -1){Scroll bar Setting}
      else {No correction - required}
      Correctedredvalue := Redvalue;{Resulting Corrected Value}
      if Greenvalue > 0 then
      Correctedgreenvalue:= Greenvalue + (Tuner.green.Position * -1)
      else
      Correctedgreenvalue:= Greenvalue;
      if Bluevalue > 0 then
      Correctedbluevalue:= Bluevalue + (Tuner.blue.Position * -1)
      else
      Correctedbluevalue:= Bluevalue;
      {Check for Valid Range 0 to 255 for the Corrected Values}
      if Correctedredvalue < 0 then Correctedredvalue := 0;
      if correctedredvalue > 255 then Correctedredvalue := 255;
      if Correctedgreenvalue < 0 then Correctedgreenvalue := 0;
      if correctedgreenvalue > 255 then Correctedgreenvalue := 255;
      if Correctedbluevalue < 0 then Correctedbluevalue := 0;
      if correctedbluevalue > 255 then Correctedbluevalue := 255;
      {Consruct New Data Line}
      Newdata[J]:= RGB(Correctedredvalue,Correctedgreenvalue,Correctedbluevalue);
     end;  {End Scan Loop}
     Ikputscanline(Tuner.Picbuf1.ctl,I,@Newdata);{Update Tune Display with new Data Line}
    end;
    Tuner.Picbuf1.Refresh;
    Screen.Cursor:= crDefault;  {Show bit Normal Cursor}
    end;{End Tune Case}
{P is Passed by the Tune Display Like 'T' above, However we Correct the Pixels Values by
adding a Percentage of the Value they already contain of each color - This is the Best Method}
'P':Begin {Alter value by 1 to 100% +/-}
 IkInit(Tuner.Picbuf1.ctl,24,Picbuf1.Xresolution,Picbuf1.Yresolution,
 RGB(0,0,0));
  For I := 0 to (Picbuf1.Yresolution - 1) do
   begin
   Screen.Cursor:= 4;  {Show bit Wait Cursor}
   Ikgetscanline(Picbuf1.ctl,I,@Imagedata);
    For J:= 1 to Picbuf1.Xresolution do
    begin{Scan Loop - Depending on Channel alter code}
    Redvalue:= Getrvalue(Imagedata[J]);
    Greenvalue:= Getgvalue(Imagedata[J]);
    Bluevalue:= Getbvalue(Imagedata[J]);
    {'250 -'  to swap top/bottoms on scroll bars - See Notes in other Units}
    {For Tune % only alter Values that already had a Value ie 0,0,0 stays 0,0,0}
    {We / by 100 to converts scroll bar range of '100 to 200' to '1 to 2' - gives us
    100 steps. Result is 'rounded' to convert to compatible integer type}
    if Redvalue  > 0 then {Apply Correction}
    Correctedredvalue:= round(Redvalue * ((250- Tuner.redprcnt.Position) / 100)) {Scroll bar Setting}
    else {No correction}
    Correctedredvalue := Redvalue;
    if Greenvalue > 0 then
    Correctedgreenvalue:= round(Greenvalue * ((250-Tuner.greenprcnt.Position) / 100))
    else
    Correctedgreenvalue:= Greenvalue;
    if Bluevalue > 0 then
    Correctedbluevalue:= round(Bluevalue * ((250-Tuner.blueprcnt.Position) / 100))
    else
    Correctedbluevalue:= Bluevalue;
    {Check For Valid Range}
    if Correctedredvalue < 0 then Correctedredvalue := 0;
    if correctedredvalue > 255 then Correctedredvalue := 255;
    if Correctedgreenvalue < 0 then Correctedgreenvalue := 0;
    if correctedgreenvalue > 255 then Correctedgreenvalue := 255;
    if Correctedbluevalue < 0 then Correctedbluevalue := 0;
    if correctedbluevalue > 255 then Correctedbluevalue := 255;
    {Build New Data Line}
    Newdata[J]:= RGB(Correctedredvalue,Correctedgreenvalue,Correctedbluevalue);
   end;  {End Scan Image Loop}
   Ikputscanline(Tuner.Picbuf1.ctl,I,@Newdata);{Update Tune Display with New Line}
  end;
  Tuner.Picbuf1.Refresh;{Refresh Preview Image}
  Screen.Cursor:= crDefault;  {Show bit Wait Cursor}
 end; {End Tune % Case 'P'}
end;{End Case select}
end;
 except
  on E: EVBXError do  MessageDlg('Resize Error - ' + E.Message, mtInformation,
  [mbOk], 0);
  on E: EConvertError do MessageDlg('Resize Error - Non Valid User Input Values.'
  ,mtInformation,[mbOk], 0);
  else
  MessageDlg('System Error.', mtInformation,
  [mbOk], 0);
  end;
end;

{Alter Brightness/Contrast - Scroll bars only pass click and up/down values. We Must store
the Last Value Applied so we can Tell if the User is Increasing or Decreasing the Value.
We then apply a FIXED value Accordingly- either Up or Down. Note That only a Click
on the Scroll bar works - 1 Click 1 Step adjustment. The Position of the Scroll bar
has no significance}
Procedure PBrightness;
begin
try
 With Tuner do{Refer to Image in Tune Screen.Buffer}
  begin
   if (Bright.Position / 100) < Lastbrightvalue then {Increase or Decrease}
   IKBrightCont(Picbuf1.ctl,0.50,0.51)
    else
    IKBrightCont(Picbuf1.ctl,0.50,0.49);
    Lastbrightvalue := (Bright.Position / 100); {Track Last Value}
  end;
  except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;


{Alter Brightness/Contrast - As Above}
Procedure PContrast;
begin
 With Tuner do{Refer to Image in Tune Screen.Buffer}
  begin
   if (Contrast.Position / 100) < Lastcontvalue then {Increase or Decrease}
   IKBrightCont(Picbuf1.ctl,0.50,0.51)
   else
   IKBrightCont(Picbuf1.ctl,0.50,0.49);
   Lastcontvalue := (Contrast.Position / 100);{Track Last Value}
  end;
 end;


end.
