{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}


unit Upref;

{This Form Contains all Options that the User Can Select and STORE IN A INI file. The basis
is that the User has a number of option Boxes they can select. All other Units if Required
refer to these Option Box Properties to Determine the Required Option. When the Form is
closed the form Saves the Current Settings of the Options Boxes to a .INI file in the
the Users Windows Directory 'BIT.INI'. When the Form is loaded the INI file is checked and
the Settings used to set the Option Boxes. This way Closing the Form writes the Settings
to Disk and Loading the Form Reads the Settings from Disk. 'Inifiles' is the Delphi
unit that provides the Function Calls}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,IniFiles, Buttons, ExtCtrls, Mask, Spin;

type
  TPREFERENCES = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Displayassignmode: TComboBox;
    Displayautoscale: TComboBox;
    GroupBox4: TGroupBox;
    Displayresizemode: TComboBox;
    Displayautosize: TComboBox;
    GroupBox5: TGroupBox;
    BitBtn1: TBitBtn;
    GroupBox6: TGroupBox;
    SpinButton1: TSpinButton;
    Jpeglabel: TLabel;
    GroupBox7: TGroupBox;
    Label1: TLabel;
    GroupBox8: TGroupBox;
    Fifoptions: TComboBox;
    GroupBox9: TGroupBox;
    GroupBox10: TGroupBox;
    Fifscale: TComboBox;
    Fifheight: TEdit;
    Fifwidth: TEdit;
    Defaults: TBitBtn;
    GroupBox12: TGroupBox;
    Defaultwidth: TLabel;
    Defaultheight: TLabel;
    SpinButton2: TSpinButton;
    SpinButton3: TSpinButton;
    GroupBox13: TGroupBox;
    SpinButton4: TSpinButton;
    SpinButton5: TSpinButton;
    Zoomwidth: TLabel;
    Zoomheight: TLabel;
    Scrollbars: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure DefaultsClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
    procedure SpinButton4DownClick(Sender: TObject);
    procedure SpinButton4UpClick(Sender: TObject);
    procedure SpinButton5DownClick(Sender: TObject);
    procedure SpinButton5UpClick(Sender: TObject);
    

    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PREFERENCES: TPREFERENCES;

implementation

{$R *.DFM}

{When the Form Is Created Read the INI FILE :- Take the First Line:-
Displayassignmode.Itemindex := ReadInteger('DisplayOptions','Assignmode',3);
DisplayAssignMode is a List Box and the ItemIndex determines which Item
is Selected - it is a Integer Value. As the Picbuf Control uses a value
of 0 to 3 to select Assignmode we can simply Apply the ItemIndex Value to the
Picbuf - it is assumed that the user places the correct Modes in the Correct
location within the List Box. We Simply Read the .INI file using READINTEGER
get the Vlaue and Apply it to the Drop down Box, this enables the Correct Item.
The Parmeters in the ReadInteger Function are 'DisplayOptions' this reflects the
section heading in the INI file, Assignmode is the Varaible Name that appears
in the INI file and 3 is a Default value that is only read if the INI file is
corrupt or has not been created. The first time the Application is run the File Is Created
and the Default values Used - Open Bit.INI in Write to View it you will see the connection
with the Above - Section NAME, Variable NAME, And Default Value}
procedure TPREFERENCES.FormCreate(Sender: TObject);
begin
{Read Values from .INI file and apply to controls}
With Tinifile.Create(changefileext(extractfilename(Application.Exename),'.INI')) do
try
{'Section', Varaible Name, Default Value}
Displayassignmode.Itemindex := ReadInteger('DisplayOptions','Assignmode',3);
Displayautoscale.Itemindex := ReadInteger('DisplayOptions','Autoscale',1);
Displayautosize.Itemindex := ReadInteger('DisplayOptions','Autosize',0);
Displayresizemode.Itemindex := ReadInteger('DisplayOptions','Resizemode',3);
Defaultwidth.Caption:= ReadString('DisplayOptions','Defaultwidth','250');
Defaultheight.Caption:= ReadString('DisplayOptions','Defaultheight','250');
Scrollbars.Checked:= ReadBool('DisplayOptions','ForceScrollBars',False);
Jpeglabel.Caption:= ReadString('File I/O','Quality','90');
Fifoptions.Itemindex := ReadInteger('File I/O','Fifoption',0);
Fifscale.Itemindex := ReadInteger('File I/O','Scale',0);
Fifheight.Text := ReadString('File I/o','Fheight','10');
Fifwidth.Text := ReadString('File I/O','Fwidth','10');
Zoomheight.Caption := ReadString('DrawingTools','Zoomheight','20');
Zoomwidth.Caption := ReadString('DrawingTools','Zoomwidth','20');
finally
free;
end;
end;

{Use Form  Close to SAVE ItemIndexes etc to Disk. If we are saving an ItemIndex we are
saving an INTEGER value so we use the WriteInteger Function. Options Exist for Strings
and Booleans etc. It is comparible to Saving a Variable to DISK rather than Memory.
Format Is WriteINTEGER['Section Heading' ie Label in INI file, Variable Name we wish
to Save - can be anything but rember to Read the Same Name, and the Value to Store
in this case we used the Item Index of the List Box.}
procedure TPREFERENCES.FormClose(Sender: TObject;
var Action: TCloseAction);
begin
With Tinifile.Create(changefileext(extractfilename(Application.Exename),'.INI')) do
try
{Save settings in .INI file - extract application name for INI name eg BIT.EXE}
{'Section', Variable Name, Value to store }
WriteInteger('DisplayOptions','Assignmode',Displayassignmode.Itemindex);
WriteInteger('DisplayOptions','Autoscale',Displayautoscale.Itemindex);
WriteInteger('DisplayOptions','Autosize',Displayautosize.Itemindex);
WriteInteger('DisplayOptions','Resizemode',Displayresizemode.Itemindex);
WriteString ('DisplayOptions','Defaultwidth',Defaultwidth.Caption);
WriteString ('DisplayOptions','Defaultheight',Defaultheight.Caption);
WriteBool('DisplayOptions','ForceScrollBars',Scrollbars.Checked);
WriteString('File I/O','Quality', Jpeglabel.Caption);
WriteInteger('File I/O','Fifoption',Fifoptions.ItemIndex);
WriteInteger('File I/O','Scale',Fifscale.ItemIndex);
WriteString('File I/O','Fheight',Fifheight.Text);
WriteString('File I/O','Fwidth',Fifwidth.Text);
WriteString('DrawingTools','Zoomheight',Zoomheight.Caption);
WriteString('DrawingTools','Zoomwidth',Zoomwidth.Caption);
finally
free;
end;
end;


{Close Form -triggers Save}
procedure TPREFERENCES.BitBtn1Click(Sender: TObject);
begin
Preferences.close;
end;


{Set Defaults - for Demo Only}
procedure TPREFERENCES.DefaultsClick(Sender: TObject);
begin
Displayassignmode.Itemindex :=3;
Displayautoscale.Itemindex := 1;
Displayautosize.Itemindex := 0;
Displayresizemode.Itemindex :=3;
end;


{This Alters the JPEG Caption - Updates Caption - the Save As then can Refer to it}
procedure TPREFERENCES.SpinButton1DownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Jpeglabel.Caption);
Value:= Value-1;
if Value < 5 then value := 5;
Jpeglabel.Caption := Inttostr(Value);
end;

{This Alters the JPEG Caption - Updates Caption - the Save As then can Refer to it}
procedure TPREFERENCES.SpinButton1UpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Jpeglabel.Caption);
Value:= Value + 1;
If Value > 100 then Value := 100;
Jpeglabel.Caption := Inttostr(Value);
end;



{Default width  down count - this is Used under the Child Displays Create form to determine
the Default Size of a Child Window}
procedure TPREFERENCES.SpinButton2DownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Defaultwidth.Caption);
Value:= Value - 10;
if Value < 25 then value := 25;
Defaultwidth.Caption := Inttostr(Value);
end;

{Default width  Up count - this is Used under the Child Displays Create form to determine
the Default Size of a Child Window}
procedure TPREFERENCES.SpinButton2UpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Defaultwidth.Caption);
Value:= Value + 10;
if Value > 500 then value := 500;
Defaultwidth.Caption := Inttostr(Value);
end;

{Default Height down count - this is Used under the Child Displays Create form to determine
the Default Size of a Child Window}
procedure TPREFERENCES.SpinButton3DownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Defaultheight.Caption);
Value:= Value - 10;
if Value < 0 then value := 500;
Defaultheight.Caption := Inttostr(Value);
end;

{Default Height  Up count - this is Used under the Child Displays Create form to determine
the Default Size of a Child Window}
procedure TPREFERENCES.SpinButton3UpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Defaultheight.Caption);
Value:= Value + 10;
if Value > 500 then value := 500;
Defaultheight.Caption := Inttostr(Value);
end;

{Dynamic Zoom Width down count - Alters and is Used by the Dynamic Zoom Function - Child
Display Mouse Move Event}
procedure TPREFERENCES.SpinButton4DownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Zoomwidth.Caption);
Value:= Value - 10;
if Value < 10 then value := 10;
Zoomwidth.Caption := Inttostr(Value);
end;

{Dynamic Zoom Width Up count - Alters and is Used by the Dynamic Zoom Function - Child
Display Mouse Move Event}
procedure TPREFERENCES.SpinButton4UpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Zoomwidth.Caption);
Value:= Value + 10;
if Value > 1000 then value := 1000;
Zoomwidth.Caption := Inttostr(Value);
end;

{Dynamic Zoom Height Down count - Alters and is Used by the Dynamic Zoom Function - Child
Display Mouse Move Event}
procedure TPREFERENCES.SpinButton5DownClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Zoomheight.Caption);
Value:= Value - 10;
if Value < 10 then value := 10;
Zoomheight.Caption := Inttostr(Value);
end;

{Dynamic Zoom Height Up count - Alters and is Used by the Dynamic Zoom Function - Child
Display Mouse Move Event}
procedure TPREFERENCES.SpinButton5UpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Zoomheight.Caption);
Value:= Value + 10;
if Value > 1000 then value := 1000;
Zoomheight.Caption := Inttostr(Value);
end;
end.
