{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

unit Utext;

{Form Name Textform. Unlike other functions the Code for the Text Function appear here -
Note:- New users shold place the function in a Global Unit - better practice}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,  ExtCtrls, VBXCtrl,
  StdCtrls, Buttons, ikCon16, Menus;

type
  TTextform = class(TForm)
    Applytext: TBitBtn;
    GroupBox1: TGroupBox;
    FontDialog: TFontDialog;
    Options: TBitBtn;
    Fnttransparent: TCheckBox;
    Fntautosize: TCheckBox;
    Fntmultiline: TCheckBox;
    Textposition: TComboBox;
    Usertext: TMemo;
    PopupMenu1: TPopupMenu;
    PinDisplaytoForeground: TMenuItem;
    PinDisplaytoBackground: TMenuItem;
    procedure ApplytextClick(Sender: TObject);
    procedure OptionsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PinDisplaytoForegroundClick(Sender: TObject);
    procedure PinDisplaytoBackgroundClick(Sender: TObject);
   
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Textform: TTextform;{Form Name}

implementation

Uses Umaster,Udisplay,UGlobvar;

{$R *.DFM}

{In all Cases we Refer to the Active Chiild as the Image we are going to place the
Text Into. A Selection Area Should be Pre-defined and then the Text Applied. Font Options
are Given and the Style Picked is Used to Update the User Text Input form. New User
should enable and 'UNDO' function.}

{Apply Text}
procedure TTextform.ApplytextClick(Sender: TObject);
begin
  try
   If Application.Mainform.Mdichildcount = 0 then Exit;{No Child Abort}
    With Application.Mainform.ActiveMDIChild as TDisplay do{Refer to Main Screen}
     begin
      Picbuf1.Text := Usertext.Text;{User Text is Edit Box. AssignText from Box to Buffer}
      {Set options not covered by font Dialog box use check box values and Index Values}
      Picbuf1.Fonttransparent := Fnttransparent.Checked; {Transparent Font}
      Picbuf1.TextAutoSize := FntAutosize.Checked; {Auto Size Font}
      Picbuf1.TextMultiLine := Fntmultiline.Checked; {Multi Line Support}
      Picbuf1.TextAlignment := Textposition.ItemIndex;{0,1,2 - Left Right Etc}
      Picbuf1.Font := Fontdialog.Font; {Set Font to Dialog box value- this also sets style etc}
      Picbuf1.Forecolor := Fontdialog.Font.Color; {Set Color}
      IkTextDraw(Picbuf1.Ctl);{Apply Text}
     end;
   except {trap}
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
   else
   MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
   [mbOk], 0);
  end;
end;

{Display Text Option Box}
{Size, Style, Underline & Strikethrough is set along with 'textstyle'}
procedure TTextform.OptionsClick(Sender: TObject);
begin
try
 Fontdialog.font := Usertext.font; {Set Dialog box to User Text Font}
 If Fontdialog.execute then{If the User Select OK}
  Begin
   UserText.font := Fontdialog.Font; {Set UserText Input Box to Selected Font}
  end;
except
   on E: EVBXError do
   MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
   + E.Message, mtInformation,
   [mbOk], 0);
   else
   MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
   [mbOk], 0);
  end;
end;

{Disable Text Function Select on Close of form By default - AH not Required?}
procedure TTextform.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  try
  MouseOption := 'Q';
  except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;

{Pin form to foreground/background - See other Unit}
procedure TTextform.PinDisplaytoForegroundClick(Sender: TObject);
begin
Textform.Formstyle := fsstayontop;
Pindisplaytobackground.Checked := False;
Pindisplaytoforeground.Checked := True;
end;

{Pin form to foreground/background}
procedure TTextform.PinDisplaytoBackgroundClick(Sender: TObject);
begin
Textform.Formstyle := fsnormal;
Pindisplaytobackground.Checked := True;
Pindisplaytoforeground.Checked := False;
end;

end.
