{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047
See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

{Form Name 'TUNER' - tune an image. This Unit is connected to the Tune Dialog Box. All controls
are standard Delphi objects. The Main Code to actually tune the Image is in Unit UGlobals.}
unit Utune;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, VBXCtrl, Ikdsp16, Buttons, Menus;

type
  TTuner = class(TForm)
    gamma: TScrollBar;
    green: TScrollBar;
    blue: TScrollBar;
    bright: TScrollBar;
    red: TScrollBar;
    contrast: TScrollBar;
    GroupBox1: TGroupBox;
    PicBuf1: TPicBuf;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Transfer: TSpeedButton;
    Preview: TSpeedButton;
    Realtime: TCheckBox;
    applygamma: TCheckBox;
    rvalue: TLabel;
    gvalue: TLabel;
    bvalue: TLabel;
    gavalue: TLabel;
    Bevel2: TBevel;
    Label9: TLabel;
    Label10: TLabel;
    Tune_Popup: TPopupMenu;
    PinDisplaytoForeground: TMenuItem;
    PinDisplaytoBackground: TMenuItem;
    redprcnt: TScrollBar;
    greenprcnt: TScrollBar;
    blueprcnt: TScrollBar;
    rpvalue: TLabel;
    gpvalue: TLabel;
    bpvalue: TLabel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Previewprcnt: TSpeedButton;
    Grabtune: TSpeedButton;
    exittune: TSpeedButton;
    procedure redChange(Sender: TObject);
    procedure greenChange(Sender: TObject);
    procedure blueChange(Sender: TObject);
    procedure TransferClick(Sender: TObject);
    procedure PreviewClick(Sender: TObject);
    procedure brightChange(Sender: TObject);
    procedure contrastChange(Sender: TObject);
    procedure gammaChange(Sender: TObject);
    procedure PinDisplaytoForegroundClick(Sender: TObject);
    procedure PinDisplaytoBackgroundClick(Sender: TObject);
    procedure redprcntChange(Sender: TObject);
    procedure greenprcntChange(Sender: TObject);
    procedure blueprcntChange(Sender: TObject);
    procedure PreviewprcntClick(Sender: TObject);
    procedure GrabtuneClick(Sender: TObject);
    procedure exittuneClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Tuner: TTuner;{Form Name is 'Tuner'}

implementation
{Remember To put the Uses Clauses in the Implementation Section to aviod Circular References-
The Uses Clause here allows form to reference each other - ie one can call the other and
Vice-Versa}
Uses Uglobals,Udisplay,Ikcon16; {We require the following units}
{$R *.DFM}


{Red Channel Calls. The Dialog Box contains a Number of Scroll Bars. These bars have
there Min/Max Values set to reflect the required change Values. Normally this is
0 to 255 reflecting possible RGB values. You will Notice that some Values are
Negateded this is Done so the Top and Bottom 'Values' or 'Ends' of the Scroll bars
are reversded.  - By default a Scroll bars Value Increases as the Control is moved
'Down' the Computer Screen. I felt that a Movement Down the Screen seamed more like a
reduction of value rather than an Increase, hence swap the values so a Down Movement
causes a Reduction in Value. Each Scroll bar calls the Sub in the Uglobal Unit. We pass
only 'T' as a parameter so the code in the Uglobal unit knows the 'Tuner' Screen
is calling it.}

{Red Scroll Bar. Each Scroll has a connected label to indicate the Set Value. Fast Machines can Handle continual
updates, however, for slow machines this can be disablded}
procedure TTuner.redChange(Sender: TObject);
begin
try
Rvalue.Caption := 'Red: ' + InttoStr(red.position * -1);{Update Caption Red}
if Realtime.checked = false then exit;{Check Option box - abort call to sub if requirded}
Rgbtune('T'); {Call Sub in Unit Uglobal - pass 'T' to Indicate 'Tune' Channel }
except {'Coverall' Trap - not good practice but OK for a demo Version's/ Some Applications}
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{As above - Green Scroll Bar}
procedure TTuner.greenChange(Sender: TObject);
begin
try
Gvalue.Caption := 'Green: ' + InttoStr(Green.position * -1);{Update Caption}
if Realtime.checked = false then exit;
Rgbtune('T'); {Call Sub pass 'T' to Indicate 'tune' Channel }
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{As Above - Blue Channel}
procedure TTuner.blueChange(Sender: TObject);
begin
try
Bvalue.Caption := 'Blue: ' + InttoStr(Blue.position * -1);{Update Caption}
if Realtime.checked = false then exit;
Rgbtune('T'); {Call Sub pass 'T' to Indicate 'tune' Channel }
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Transfer Image to main screen.  On request we copy the 'Preview' image on the Tuner
Dialogue Box to the Main Screen - if the Main Screen has an Active Image}
procedure TTuner.TransferClick(Sender: TObject);
begin
try
If Application.Mainform.MDIChildcount = 0 then Exit; {No Image}
If Tuner.Picbuf1.Contents <> 1 then  Exit;{No Valid Image}
With Application.Mainform.ActiveMDIchild as TDisplay do  {Reference Valid Image}
begin
IkAssign(Picbuf1.Ctl,0,Tuner.Picbuf1.Ctl,0); {Do the Transfer}
end;
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Preview alterations + Apply Gamma if selected. See notes Above.  If a Gamma value is set Apply Gamma
only do not call the tune function. This also allows slow machines a manual update}
procedure TTuner.PreviewClick(Sender: TObject);
begin
try
if Applygamma.checked = true then { If 'Gamma' Selected Apply Gamma only }
ikGamma(Picbuf1.ctl,Gamma.Position) { Apply Gamma based on Scroll Bar Location}
else { No Gamma Requested }
Rgbtune('T');{Call sub T parameters for Tune Required if gamma not checked}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Alter Image Brightness/Contrast - Use Sub Call - Unit Uglobal}
procedure TTuner.brightChange(Sender: TObject);
begin
try
If Picbuf1.Contents <> 1 then Exit;
PBrightness;{Call Sub}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Alter Image Brightness/Contrast - Use Sub Call - Unit Uglobal}
procedure TTuner.contrastChange(Sender: TObject);
begin
try
If Picbuf1.Contents <> 1 then Exit;
PContrast;{Call Sub}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Gamma - Label Update call - Update Gamma caption to reflect Scroll Bar Position.  }
procedure TTuner.gammaChange(Sender: TObject);
begin
try
Gavalue.Caption := 'Gamma: ' + InttoStr(gamma.position);{Update Caption - Convert to String}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Pin form to Foreground. Normally a Dialogue box is Always on top. This Means that by
default a Dialogue Box is always visible to the User. This can Cause problems in that
it can cover the Child Windows. This allows the User to remove the Always on Top
Status. This Causes the Form to Drop to the Background if Requirded. Events are connectded
to a Popup Menu}
procedure TTuner.PinDisplaytoForegroundClick(Sender: TObject);
begin
Tuner.Formstyle := fsStayontop; {Alter form {Property}
PinDisplaytoForeground.Checked:= True; {Check/uncheck Items as requirded}
PinDisplaytoBackground.Checked:= False;
end;

{Pin form to Background - as above}
procedure TTuner.PinDisplaytoBackgroundClick(Sender: TObject);
begin
Tuner.Formstyle := fsNormal;
PinDisplaytoForeground.Checked:= False;
PinDisplaytoBackground.Checked:= True;
end;

{Update Displays and call 'Tune' sub in Uglobal passing 'P' for percent function}
{Note Captions are scaled to read + 0 to 100 and -0 to -100% values
taking the value away from 250 swaps the scroll bars ends - only required so +
values appear to be in the up position for the scroll bar Red Channel - See notes
above. The Follwing events are Linked to the 3 Scroll bars on the right of the
Tune Display that controls % alterations - See Notes in Uglobal Unit. Note:-
the Various Calculations for Lable Updates is to calculate A +/- Scale of
-100 to 0 to + 100 Display, with the + 100 to the top of the Display.}
procedure TTuner.redprcntChange(Sender: TObject);
begin
try
if (250 - redprcnt.Position) >= 100 then
Rpvalue.Caption := 'Red: ' + InttoStr(((250 - redprcnt.Position) - 100)) + ' %'
else
Rpvalue.Caption := 'Red: ' + InttoStr((((250 - redprcnt.Position - 100) * 2)))+ ' %';
if Realtime.checked = false then exit;
Rgbtune('P'); {Call Sub pass 'P' to Indicate 'tune %' Channel }
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;
{Update Displays and call Tune sub passing 'P' for percent function}
{Note Captions are scaled to read + 0 to 100 and -0 to -100% values
taking the value away from 250 swaps the scroll bars ends - only required so +
values appear to be in the up position for the scroll bar Green Channel}
procedure TTuner.greenprcntChange(Sender: TObject);
begin
try
if (250 - Greenprcnt.Position)>= 100 then
Gpvalue.Caption := 'Green: ' + InttoStr(((250 - greenprcnt.Position) - 100)) + ' %'
else
Gpvalue.Caption := 'Green: ' + InttoStr((((250 - greenprcnt.position -100) * 2))) + ' %';
if Realtime.checked = false then exit;
Rgbtune('P'); {Call Sub pass 'P' to Indicate 'tune %' Channel }
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;
{Update Displays and call Tune sub passing 'P' for percent function}
{Note Captions are scaled to read + 0 to 100 and -0 to -100% values
taking the value away from 250 swaps the scroll bars ends - only required so +
values appear to be in the up position for the scroll bar Blue Channel}
procedure TTuner.blueprcntChange(Sender: TObject);
begin
try
if (250 - Blueprcnt.Position)>= 100 then
Bpvalue.Caption := 'Blue: ' + InttoStr(((250 - blueprcnt.Position) -100))+ ' %'
else
Bpvalue.Caption := 'Blue: ' + InttoStr((((250 - Blueprcnt.Position - 100) *2))) + ' %';
if Realtime.checked = false then exit;
Rgbtune('P'); {Call Sub pass 'P' to Indicate 'tune %' Channel }
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Call Preview for % function again do gamma only if Gamma Checked - See above Notes}
procedure TTuner.PreviewprcntClick(Sender: TObject);
begin
try
if Applygamma.checked = true then {If 'Gamma' Selected Apply Gamma only}
ikGamma(Picbuf1.ctl,Gamma.Position){Call Function - Image is Preview image in tune display}
else{If no Gamma Requested update Image with % appllied}
Rgbtune('P');{Call sub T parameters for Tune Required if gamma not checked}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Grab Active Childs Image and Place in Buffer. This allows the User to Copy the Active
Child Display into the Tune Preview. Remember that the Function in the Uglobal Unit
always refers to the Active Child Display - NOT THE TUNE PREVIEW IMAGE.}
procedure TTuner.GrabtuneClick(Sender: TObject);
begin
try
If Application.Mainform.MDIchildcount = 0 then Exit; {Is there a Image}
With Application.Mainform.ActiveMDIchild as TDisplay do{Reference it}
begin
If Picbuf1.ColorDepth < 24 then {Image Must Be 24 Bit for function}
begin
MessageDlg('Image Must Be 24 Bit Convert If Required. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
Exit; {Abort if not 24 Bit}
end;
ikassign(Tuner.Picbuf1.ctl,0,Picbuf1.ctl,0); {Copy Valid Image Accross}
end;
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Hide Form - This 'Closes' the form but does not erase it. The Tune Preview image is
removded to free memory - called from button}
procedure TTuner.exittuneClick(Sender: TObject);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
Tuner.Hide;
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Kill Image on Close - as above but occurs if the form is closed by another method}
procedure TTuner.FormClose(Sender: TObject; var Action: TCloseAction);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Kill Image on hide - ocuurs if the form is hidded by any Method - Really a Duplicate
of Close function call but does no harm}
procedure TTuner.FormHide(Sender: TObject);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

end.
